      subroutine fvfmd(g,u1,u2,u3,mat)
c----------------------------------------------------------------------c
c Returns a matrix element
c
c          mat=u1*u2*(gp*P+ + gm*P-)*u3.
c
c Input: u2 - vector,
c        u1,u3 - spinors
c        g - a fermion-fermion-vector-boson coupling.
c
c The gamma matrices are taken in the Weyl representation as in the 
c paper by K. Kolodziej, M. Zralek, Phys. Rev. D43 (1991) 3619
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 16 May, 2007; modified on 23 May, 2007 (unnecesary option 'iv'
c                                                            cancelled)
c----------------------------------------------------------------------c
      implicit none

      integer, parameter :: dp=kind(1.d0)
      complex(dp), parameter :: ocom=(0.d0,0.d0),icom=(0.d0,1.d0)

      complex(dp) :: g(2),mat,u2(0:3),u1(4),u3(4)

      mat=g(2)*((u1(3)*(u2(0)+u2(3))+u1(4)*(u2(1)+icom*u2(2)))*u3(1)
     &         +(u1(3)*(u2(1)-icom*u2(2))+u1(4)*(u2(0)-u2(3)))*u3(2))

      if (g(1) /= ocom) then
       mat=mat
     &    +g(1)*((u1(1)*(u2(0)-u2(3))+u1(2)*(-u2(1)-icom*u2(2)))*u3(3)
     &          +(u1(1)*(-u2(1)+icom*u2(2))+u1(2)*(u2(0)+u2(3)))*u3(4))
      end if

      end subroutine fvfmd



