      subroutine ggggkk(iv,u1,n1,p1,u2,n2,p2,u3,n3,p3,u,n,p,g,mass,wdth)
c----------------------------------------------------------------------c
c Returns a generalized polarization vector being a contraction of
c a quartic gluon vertex with three polarization vectors
c
c Input: j1,j2,j3,j4 - bosons,
c        g - a quartic gluon coupling.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 11 April, 2006; modified on 27 April, 2006, 16 February, 2007;
c                             18 May, 2007 (interface changed)
c----------------------------------------------------------------------c

      implicit none

      integer, parameter :: dp=kind(1.d0)
      integer :: iv,n1,n2,n3,n,i1,i2,i3,i

      real(dp), dimension(0:3) :: p1,p2,p3,p
      real(dp) :: mass,wdth
      complex(dp) :: g,gden,
     &               u1(0:3,n1),u2(0:3,n2),u3(0:3,n3),u(0:3,n)

      p=-p1-p2-p3

      gden=g/cmplx(p(0)**2-p(1)**2-p(2)**2-p(3)**2-mass**2,
     &                                          mass*wdth,dp)

      i=0

      if (iv == 1) then

      do i3=1,n3
       do i2=1,n2
        do i1=1,n1
         i=i+1
         u(:,i)=gden*(
     &             (u2(0,i2)*u3(0,i3)
     &             -u2(1,i2)*u3(1,i3)
     &             -u2(2,i2)*u3(2,i3)
     &             -u2(3,i2)*u3(3,i3))*u1(:,i1)
     &            -(u1(0,i1)*u3(0,i3)
     &             -u1(1,i1)*u3(1,i3)
     &             -u1(2,i1)*u3(2,i3)
     &             -u1(3,i1)*u3(3,i3))*u2(:,i2))
        end do
       end do
      end do

      else if (iv == 2) then

      do i3=1,n3
       do i2=1,n2
        do i1=1,n1
         i=i+1
         u(:,i)=gden*(
     &             (u1(0,i1)*u3(0,i3)
     &             -u1(1,i1)*u3(1,i3)
     &             -u1(2,i1)*u3(2,i3)
     &             -u1(3,i1)*u3(3,i3))*u2(:,i2)
     &            -(u1(0,i1)*u2(0,i2)
     &             -u1(1,i1)*u2(1,i2)
     &             -u1(2,i1)*u2(2,i2)
     &             -u1(3,i1)*u2(3,i2))*u3(:,i3))
        end do
       end do
      end do

      else if (iv == 3) then

      do i3=1,n3
       do i2=1,n2
        do i1=1,n1
         i=i+1
         u(:,i)=gden*(
     &             (u1(0,i1)*u2(0,i2)
     &             -u1(1,i1)*u2(1,i2)
     &             -u1(2,i1)*u2(2,i2)
     &             -u1(3,i1)*u2(3,i2))*u3(:,i3)
     &            -(u3(0,i3)*u2(0,i2)
     &             -u3(1,i3)*u2(1,i2)
     &             -u3(2,i3)*u2(2,i2)
     &             -u3(3,i3)*u2(3,i2))*u1(:,i1))
        end do
       end do
      end do

      else

      write(*,*)'ggggkk.f: Wrong value of iv',iv

      end if

      end subroutine ggggkk
