      subroutine colsqkk(ineq0)
c=============================================================================c
c Calculates colour factors and wites down the nonzero ones
c=============================================================================c
 
      use rcolms
 
      real(dp), dimension(rdgs*(rdgs+1)/2) :: c2fd
 
c SU(3) group generators and structure constants:
 
      t(1,1,:)=(/ ocom, onec, ocom/)
      t(1,2,:)=(/ onec, ocom, ocom/)
      t(1,3,:)=(/ ocom, ocom, ocom/)
 
      t(2,1,:)=(/ ocom,-icom, ocom/)
      t(2,2,:)=(/ icom, ocom, ocom/)
      t(2,3,:)=(/ ocom, ocom, ocom/)
 
      t(3,1,:)=(/ onec, ocom, ocom/)
      t(3,2,:)=(/ ocom,-onec, ocom/)
      t(3,3,:)=(/ ocom, ocom, ocom/)
 
      t(4,1,:)=(/ ocom, ocom, onec/)
      t(4,2,:)=(/ ocom, ocom, ocom/)
      t(4,3,:)=(/ onec, ocom, ocom/)
 
      t(5,1,:)=(/ ocom, ocom,-icom/)
      t(5,2,:)=(/ ocom, ocom, ocom/)
      t(5,3,:)=(/ icom, ocom, ocom/)
 
      t(6,1,:)=(/ ocom, ocom, ocom/)
      t(6,2,:)=(/ ocom, ocom, onec/)
      t(6,3,:)=(/ ocom, onec, ocom/)
 
      t(7,1,:)=(/ ocom, ocom, ocom/)
      t(7,2,:)=(/ ocom, ocom,-icom/)
      t(7,3,:)=(/ ocom, icom, ocom/)
 
      t(8,1,:)=(/ onec, ocom, ocom/)/sqrt(3.d0)
      t(8,2,:)=(/ ocom, onec, ocom/)/sqrt(3.d0)
      t(8,3,:)=(/ ocom, ocom,-2.d0*onec/)/sqrt(3.d0)
 
      t=t/2.d0
 
      f=0.d0
 
      f(1,2,3)=1.d0
      f(1,4,7)=0.5d0
      f(2,4,6)=0.5d0
      f(2,5,7)=0.5d0
      f(3,4,5)=0.5d0
      f(1,5,6)=-0.5d0
      f(3,6,7)=-0.5d0
      f(4,5,8)=sqrt(3.d0)/2.d0
      f(6,7,8)=sqrt(3.d0)/2.d0
 
      do i1=1,nc2
       do i2=i1,nc2
        do i3=i2,nc2
         if (f(i1,i2,i3) /= 0.d0) then
          f(i1,i3,i2)=-f(i1,i2,i3)
          f(i2,i1,i3)=-f(i1,i2,i3)
          f(i2,i3,i1)=f(i1,i2,i3)
          f(i3,i1,i2)=f(i1,i2,i3)
          f(i3,i2,i1)=-f(i1,i2,i3)
         end if
        end do
       end do
      end do
 
      f=icom*f
 
      d=0.d0
 
      do j=1,ncls
       d(j,j)=1.d0
      end do
 
      c2fd=0.d0
 
 
      cfd=ocom
 
      call cfdkk1
 
      i=0
 
      do j=1,rdgs
      do k=j,rdgs
       i=i+1
       c2fd(i)=c2fd(i)+conjg(cfd(j))*cfd(k)
      end do
      end do
 
 
      open(unit=30,file='colfacts.f',status='replace',action='write')
 
      i=0
      ineq0=0
 
      do j=1,rdgs
       do k=j,rdgs
        i=i+1
        if (abs(c2fd(i)) > rcold) then
         ineq0=ineq0+1
         write(30,'(i10,i10,e20.12)') j,k,c2fd(i)
        end if
       end do
      end do
 
      close(30)
 
      end subroutine colsqkk
